"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.useDeepCompareEffect = void 0;
var eq_1 = __importDefault(require("lodash/eq"));
var react_1 = require("react");
function useDeepCompareMemoize(value) {
    var ref = (0, react_1.useRef)(value);
    // it can be done by using useMemo as well
    // but useRef is rather cleaner and easier
    if (!(0, eq_1["default"])(value, ref.current)) {
        ref.current = value;
    }
    return ref.current;
}
function useDeepCompareEffect(callback, dependencies) {
    (0, react_1.useEffect)(callback, dependencies.map(useDeepCompareMemoize));
}
exports.useDeepCompareEffect = useDeepCompareEffect;
//# sourceMappingURL=useDeepCompareEffect.js.map