/// <reference types="react" />
import type { Asset } from '../../contentful/types';
import { UseQueryResult } from './useQuery';
export type UseFindAssetResult = UseQueryResult<Asset | null | undefined>;
/**
 * Queries the dataSource for an asset by ID.
 *
 * If the asset does not exist, the result will be null.
 * The result will be undefined while the query is loading.
 */
export declare function useFindAsset(id: string, 
/** Overrides the dependency list to control when the query is re-run */
deps?: React.DependencyList): UseFindAssetResult;
