/// <reference types="react" />
import type { Entry } from '../../contentful/types';
import { UseQueryResult } from './useQuery';
export type UseFindEntryResult<T> = UseQueryResult<Entry<T> | null | undefined>;
/**
 * Queries the dataSource for an entry by ID.
 * The entry will be resolved down to the specified depth if provided.
 *
 * If the entry does not exist, the result will be null.
 * The result will be undefined while the query is loading.
 */
export declare function useFindEntry<T extends Record<string, unknown> = any>(id: string, options?: {
    include?: number;
}, 
/** Overrides the dependency list to control when the query is re-run */
deps?: React.DependencyList): UseFindEntryResult<T>;
